<template>
  <div class="image-container">
    <div class="image-main" v-if="product.images">
      <div
        id="zoomImage"
        :style="{ backgroundImage: `url(${selectedImage})` }"
        @mousemove="handleZoomImageMove"
        @mouseleave="handleZoomImageLeave"
        @click="show()"
      >
        <img
          v-if="showMainImage"
          id="mainImage"
          :src="selectedImage"
          width="100%"
        />
      </div>
    </div>
    <div class="slide-wrapper">
      <img
        v-if="product.images && product.images.length > 4"
        @click="handleScrollLeft"
        src="~/assets/images/arrow-left.png"
        class="arrow"
      />
      <div id="slider" :style="{ width: sliderWidth }">
        <img
          class="thumbnail"
          v-for="(image, idx) in product.images"
          :key="idx"
          :src="image.image"
          @click="handleSelectedThumbnail(idx, $event)"
          width="100%"
        />
      </div>
      <img
        v-if="product.images && product.images.length > 4"
        @click="handleScrollRight"
        src="~/assets/images/arrow-right.png"
        class="arrow"
      />
    </div>
    <div>
      <client-only>
        <vue-easy-lightbox
          :visible="visible"
          :index="index"
          :imgs="imgs"
          @hide="visible = false"
        />
      </client-only>
    </div>
  </div>
</template>

<script>
import { mapState } from "vuex";
export default {
  props: {
    product: {
      type: Object,
      default: null
    }
  },
  data() {
    return {
      visible: false,
      index: 0, // default: 0,
      imgs: []
    };
  },
  computed: {
    ...mapState({
      selectedImage: state => state.products.selectedImage
    }),
    sliderWidth() {
      return this.selectedImage > 4 ? 400 : 470;
    },
    showMainImage() {
      return typeof window !== "undefined" && window.innerWidth <= 600;
    }
  },
  mounted() {
    this.imgs = [];
    setTimeout(() => {
      this.product.images.forEach(element => {
        this.imgs.push(element.image);
      });
    }, 1000);
  },
  methods: {
    show() {
      this.visible = true;
    },
    handleScrollLeft() {
      document.getElementById("slider").scrollIntoView({
        behavior: "smooth"
      });
      document.getElementById("slider").scrollLeft -= 180;
    },
    handleScrollRight() {
      document.getElementById("slider").scrollIntoView({
        behavior: "smooth"
      });
      document.getElementById("slider").scrollLeft += 180;
    },
    handleSelectedThumbnail(idx, e) {
      this.index = idx;
      let thumbnails = document.getElementsByClassName("thumbnail");
      let activeImage = document.getElementsByClassName("active");
      if (activeImage.length > 0) {
        activeImage[0].classList.remove("active");
      }
      e.target.classList.add("active");
      this.$store.commit(
        "products/SET_SELECTED_IMAGE",
        e.srcElement.currentSrc
      );
      this.$store.commit("products/SET_SELECTED_COLOR", {});
    },
    handleZoomImageMove(e) {
      if (window.innerWidth > 600) {
        let img = new Image();
        let imgsrc =
          e.srcElement.style || window.getComputedStyle(e.srcElement, false);
        imgsrc = imgsrc.backgroundImage.slice(4, -1).replace(/"/g, "");

        // load image + zoom
        img.src = imgsrc;

        var imgWidth = img.naturalWidth;
        var imgHeight = img.naturalHeight;
        var ratio = imgHeight / imgWidth;
        var percentage = ratio * 100 + "%";

        var boxWidth = e.srcElement.clientWidth,
          xPos = e.pageX - e.srcElement.offsetLeft,
          yPos = e.pageY - e.srcElement.offsetTop,
          // xPos = e.layerX - e.srcElement.offsetLeft,
          // yPos = e.layerY - e.srcElement.offsetTop,
          xPercent = xPos / (boxWidth / 100) + "%",
          yPercent = yPos / ((boxWidth * ratio) / 100) + "%";

        Object.assign(e.srcElement.style, {
          backgroundPosition: xPercent + " " + yPercent,
          backgroundSize: imgWidth + "px"
        });
      }
    },
    handleZoomImageLeave(e) {
      if (window.innerWidth > 600) {
        Object.assign(e.srcElement.style, {
          backgroundPosition: "center",
          backgroundSize: "cover"
        });
      }
    }
  }
};
</script>
<style lang="scss" scoped>
#zoomImage {
  width: 320px;
  height: 320px;
  background-position: center;
  background-size: cover;
  border-radius: 8px;
}

.image-container {
  top: 109px;
  margin-top: 40px;

  .image-main {
    overflow: hidden;
    border-radius: 8px;
    margin-bottom: 10px;
    width: 100%;
    height: 100%;
    cursor: crosshair;
    text-align: center;
    background-repeat: no-repeat;
    background-size: 200%;
    animation: 0.5s ease-in-out 0s 1 normal none running animation-12ap7ro;
    display: flex;
    justify-content: center;
  }

  .slide-wrapper img {
    max-width: 100%;
  }
}

.slide-wrapper {
  max-width: 5000px;
  display: flex;
  min-height: 100px;
  align-items: center;
  justify-content: center;
}
#slider {
  display: flex;
  flex-wrap: nowrap;
  overflow-x: hidden;
}

.thumbnail {
  object-fit: cover;
  max-width: 180px;
  max-height: 100px;
  cursor: pointer;
  opacity: 0.5;
  margin: 5px;
  border: 2px solid black;
  width: 80px;
}

.thumbnail:hover {
  opacity: 1;
}

.active {
  opacity: 1;
}

.arrow {
  width: 30px;
  height: 30px;
  cursor: pointer;
  transition: 0.3s;
}

.arrow:hover {
  opacity: 5;
  width: 35px;
  height: 35px;
}

@media (max-width: 600px) {
  .image-main {
    width: 100%;
    height: 100%;
  }
  #zoomImage {
    img {
      display: inline-block;
    }
  }
  .image-container .slide-wrapper img {
    max-width: 100%;
  }

  .slide-wrapper {
    justify-content: center;
  }
}

@media (max-width: 1300px) {
  .image-main {
    width: 446px;
    height: 446px;
    display: flex;
    justify-content: center;
  }
}
</style>
